import 'dart:convert';
import 'dart:io';

import 'package:http/http.dart' as http;

import 'BexModel.dart';

class BexNetwork {
  static const String _BASE_URL = "https://preprod.bkmexpress.com.tr";
  static const String _MERCHANT_ID = "2CBB2A88-1768-4565-B052-7DF37738DBCF";
  static const String _SIGN = "sign";
  static const String _UNIQUE_REF_NO = "uniqRefNo123";

  static Future<String> requestGetConsumerId() async {
    return sendRequest("/BKMExpressTestMerchant/rest/getConsumerId.do", "{}").then((response) {
      return TokenResponse.fromJson(response).token;
    }).catchError((e) {
      throw e;
    });
  }

  static Future<String> requestGetReSubmitTicket(String consumerId) async {
    ReSubmitTicketRequest request = new ReSubmitTicketRequest(consumerId, _MERCHANT_ID, _SIGN, _UNIQUE_REF_NO);
    return sendRequest("/BKMExpress/service/quickpayment/getTicketByConsumerId.do", json.encode(request.toJson()))
        .then((response) {
      return ReSubmitTicketResponse.fromJson(response).ticket;
    }).catchError((e) {
      throw e;
    });
  }

  static Future<String> requestGetTokenForInitPayment() async {
    String requestBody =
        "{\"sAmount\":\"5,55\",\"bankList\":[{\"bankCode\":\"0010\",\"instList\":[1]}],\"cAmount\":\"0,00\"}";
    return sendRequest("/BKMExpressTestMerchant/rest/getTokenForInitPayment.do", requestBody).then((response) {
      return TokenResponse.fromJson(response).token;
    }).catchError((e) {
      throw e;
    });
  }

  static Future<dynamic> sendRequest(url, requestBody) async {
    final response = await http.post(_BASE_URL + url,
        headers: {HttpHeaders.contentTypeHeader: "application/json"}, body: requestBody);

    print("Url: " + _BASE_URL + url);
    print("Request: " + requestBody);
    print("Response: " + response.body);

    if (response.statusCode == 200) {
      return json.decode(response.body);
    } else {
      throw Exception('Failed to load post with code ' + response.statusCode.toString());
    }
  }
}
