#import "BexFlutterPlugin.h"
#import "BexSdk.h"

@implementation BexFlutterPlugin

static FlutterMethodChannel* callbackChannel;

static NSString *const SET_DEBUG_MODE = @"setDebugMode";
static NSString *const SUBMIT_CONSUMER = @"submitConsumer";
static NSString *const RESUBMIT_CONSUMER = @"resubmitConsumer";
static NSString *const PAYMENT = @"payment";

+ (void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {
    FlutterMethodChannel* channel = [FlutterMethodChannel methodChannelWithName:@"bex_flutter_plugin" binaryMessenger:[registrar messenger]];
    callbackChannel = [FlutterMethodChannel methodChannelWithName:@"bex_flutter_plugin/callback" binaryMessenger:[registrar messenger]];
    BexFlutterPlugin* instance = [[BexFlutterPlugin alloc] init];
    [registrar addMethodCallDelegate:instance channel:channel];
}

- (void)handleMethodCall:(FlutterMethodCall*)call result:(FlutterResult)result {
  if ([SET_DEBUG_MODE isEqualToString:call.method]) {
      NSNumber* isDebugMode = call.arguments[@"isDebugMode"];
      [BexSdk setDebugMode:(BOOL) isDebugMode];
  } else if ([SUBMIT_CONSUMER isEqualToString:call.method]) {
      NSString* token = call.arguments[@"token"];
      [BexSdk submitConsumer:token];
  } else if ([RESUBMIT_CONSUMER isEqualToString:call.method]) {
      NSString* ticket = call.arguments[@"ticket"];
      [BexSdk resubmitConsumer:ticket];
  } else if ([PAYMENT isEqualToString:call.method]) {
      NSString* token = call.arguments[@"token"];
      [BexSdk payment:token];
  } else {
    result(FlutterMethodNotImplemented);
  }
}

+ (void)sendMessage:(NSString*)method params:(NSDictionary*)params {
    [callbackChannel invokeMethod:method arguments:params];
}

@end
